/*Sorry about how this test routine was built for testing strcasestr.c
 *I'm not experienced enough to compile this correctly as a library yet,
 *therefore cut-n-pasted strcasestr.c into here. This strcasestr
 *should match the strcasestr.c as per attached file since I cut-n-pasted,
 *new routine here each time I made fix (just to be sure), but if in doubt
 *either try it as library component (as it should be) or delete the
 *strcasestr() routine below and copy-n-paste like I did  :-)
 *
 *Jose Da Silva.  April 8, 2004
 */

typedef unsigned chartype;

#undef strcasestr
#undef __strcasestr

char *
strcasestr (phaystack, pneedle)
     const char *phaystack;
     const char *pneedle;
{
  register const unsigned char *haystack, *needle;
  register chartype bl, bu, cl, cu;

  haystack = (const unsigned char *) phaystack;
  needle = (const unsigned char *) pneedle;

  bl = _tolower (*needle);
  if (bl != '\0')
    {
      bu = _toupper (bl);
      haystack--;				/* possible ANSI violation */
      do
	{
	  cl = *++haystack;
	  if (cl == '\0')
	    goto ret0;
	}
      while ((cl != bl) && (cl != bu));

      cl = _tolower (*++needle);
      if (cl == '\0')
	goto foundneedle;
      cu = _toupper (cl);
      ++needle;
      goto jin;

      for (;;)
        {
          register chartype a;
	  register const unsigned char *rhaystack, *rneedle;

	  do
	    {
	      a = *++haystack;
	      if (a == '\0')
		goto ret0;
	      if ((a == bl) || (a == bu))
		break;
	      a = *++haystack;
	      if (a == '\0')
		goto ret0;
shloop:
	      ;
	    }
          while ((a != bl) && (a != bu));

jin:	  a = *++haystack;
	  if (a == '\0')
	    goto ret0;

	  if ((a != cl) && (a != cu))
	    goto shloop;

	  rhaystack = haystack-- + 1;
	  rneedle = needle;
	  a = _tolower (*rneedle);

	  if (_tolower (*rhaystack) == (int) a)
	    do
	      {
		if (a == '\0')
		  goto foundneedle;
		++rhaystack;
		a = _tolower (*++needle);
		if (_tolower (*rhaystack) != (int) a)
		  break;
		if (a == '\0')
		  goto foundneedle;
		++rhaystack;
		a = _tolower (*++needle);
	      }
	    while (_tolower (*rhaystack) == (int) a);

	  needle = rneedle;		/* took the register-poor approach */

	  if (a == '\0')
	    break;
        }
    }
foundneedle:
  return (char*) haystack;
ret0:
  return 0;
}

int main(int argc, char *argv[])
{
  char *haystack = "hello world";
  char *value;

  /* return pointer to haystack if no needle */
  value = (char *)strcasestr(haystack, "\0");
  if (value == haystack)
    printf("result 1 = no needle so returned pointer to haystack.\n");
  else
    printf("result 1 = returned wrong value.\n");

  /* 2..18, search for a 1char in haystack (test bl 7 bh, cl expected as 0) */
  printf("result 2, expect A, => <%s>\n", strcasestr("A", "A")); /* should return a or A */
  printf("result 3, expect a, => <%s>\n", strcasestr("a", "A"));
  printf("result 4, expect A, => <%s>\n", strcasestr("A", "a"));
  printf("result 5, expect a, => <%s>\n", strcasestr("a", "a"));

  printf("result 6, expect null, => <%s>\n", strcasestr("A", "B")); /* should return null */
  printf("result 7, expect null, => <%s>\n", strcasestr("a", "B"));
  printf("result 8, expect null, => <%s>\n", strcasestr("A", "b"));
  printf("result 9, expect null, => <%s>\n", strcasestr("a", "b"));

  printf("result 10, expect B, => <%s>\n", strcasestr("AB", "B")); /* look past 1st char, find B or b */
  printf("result 11, expect B, => <%s>\n", strcasestr("aB", "b"));
  printf("result 12, expect b, => <%s>\n", strcasestr("Ab", "B"));
  printf("result 13, expect b, => <%s>\n", strcasestr("ab", "b"));

  printf("result 14, expect B, => <%s>\n", strcasestr("AAB", "B")); /* look past 1st char, find B or b */
  printf("result 15, expect B, => <%s>\n", strcasestr("aAB", "b"));
  printf("result 16, expect b, => <%s>\n", strcasestr("Aab", "B"));
  printf("result 17, expect b, => <%s>\n", strcasestr("aab", "b"));

  printf("result 18, expect BCD, => <%s>\n", strcasestr("ABCD", "B")); /* return string BCD or bCD */
  printf("result 19, expect BCD, => <%s>\n", strcasestr("aBCD", "b"));
  printf("result 20, expect bCD, => <%s>\n", strcasestr("AbCD", "B"));
  printf("result 21, expect bCD, => <%s>\n", strcasestr("abCD", "b"));

  /* 22...37, search for 2char string in haystack (test bl, bh, cl, ch) */
  printf("result 22 = <%s>\n", strcasestr("ABCD", "BC")); /* return string BCD or bCD */
  printf("result 23 = <%s>\n", strcasestr("aBCD", "Bc"));
  printf("result 24 = <%s>\n", strcasestr("ABCD", "bC"));
  printf("result 25 = <%s>\n", strcasestr("aBCD", "bc"));
  printf("result 26 = <%s>\n", strcasestr("ABBCD", "BC"));
  printf("result 27 = <%s>\n", strcasestr("abBCD", "Bc"));
  printf("result 28 = <%s>\n", strcasestr("ABBCD", "bC"));
  printf("result 29 = <%s>\n", strcasestr("abBCD", "bc"));

  printf("result 30 = <%s>\n", strcasestr("ABCD", "BC"));
  printf("result 31 = <%s>\n", strcasestr("aBcD", "BC"));
  printf("result 32 = <%s>\n", strcasestr("AbCD", "BC"));
  printf("result 33 = <%s>\n", strcasestr("abcD", "BC"));
  printf("result 34 = <%s>\n", strcasestr("ABBCD", "BC"));
  printf("result 35 = <%s>\n", strcasestr("abBcD", "BC"));
  printf("result 36 = <%s>\n", strcasestr("ABbCD", "BC"));
  printf("result 37 = <%s>\n", strcasestr("abbcD", "BC"));

  /* 38...53, search for 2char string in haystack (test bl, bh, cl, ch, a) */
  /* this routine provides a false start by showing bcb, therefore forcing to look again for bcd */
  printf("result 38 = <%s>\n", strcasestr("ABCBCD", "BCD")); /* should return string BCD or bCD */
  printf("result 39 = <%s>\n", strcasestr("aBCBCD", "BCd")); /* upper/lower needle vs upper haystack */
  printf("result 40 = <%s>\n", strcasestr("ABCBCD", "BcD"));
  printf("result 41 = <%s>\n", strcasestr("aBCBCD", "Bcd"));
  printf("result 42 = <%s>\n", strcasestr("ABCBCD", "bCD"));
  printf("result 43 = <%s>\n", strcasestr("aBCBCD", "bCd"));
  printf("result 44 = <%s>\n", strcasestr("ABCBCD", "bcD"));
  printf("result 45 = <%s>\n", strcasestr("aBCBCD", "bcd"));

  printf("result 46 = <%s>\n", strcasestr("ABCBCD", "BCD")); /* should return string BCD or bCD */
  printf("result 47 = <%s>\n", strcasestr("aBCBCd", "BCD")); /* needle vs upper lower haystack */
  printf("result 48 = <%s>\n", strcasestr("ABCBcD", "BCD"));
  printf("result 49 = <%s>\n", strcasestr("aBCBcd", "BCD"));
  printf("result 50 = <%s>\n", strcasestr("ABCbCD", "BCD"));
  printf("result 51 = <%s>\n", strcasestr("aBCbCd", "BCD"));
  printf("result 52 = <%s>\n", strcasestr("ABCbcD", "BCD"));
  printf("result 53 = <%s>\n", strcasestr("aBCbcd", "BCD"));

  /* should return null because can't find BCE */
  value = (char *)strcasestr("ABCBCD", "BCE");
  if (value == 0)
    printf("result 54 = returned null pointer.\n");
  else
    printf("result 54 = returned wrong value, expected 0\n");

  /* should return null because can't find BCDE */
  value = (char *)strcasestr("ABCBCDBCDBCD", "BCDE");
  if (value == 0)
    printf("result 55 = returned null pointer.\n");
  else
    printf("result 55 = returned wrong value, expected 0\n");

  return 0;
}
